#include "../include/Adlsys.h"
#include "../include/Adldev.h"
#include "../include/Adllib.h"


/*---- Local function in other module ----*/
extern void S593_ClearController(U32 dwPort);
extern void PLX90_ClearController(U32 dwPort);
extern void P9080_ClearController(U32 dwPort);

void AdlOpenDbx(register PPCI_DBX pDbx);
void AdlCloseDbx(register PPCI_DBX pDbx);
//void AdlDropDbx(register PPCI_DBX pDbx);

void AdlCloseDsen(register PPCI_DSEN pDsen);
void AdlDropDsen(register PPCI_DSEN pDsen);


/*
 * PCI Controller Reset
 */
void AdlControllerReset(PPCI_DEVEXT pDevExt, U32 reset_9050) //Alex 12/09/98
{
    switch(pDevExt->wPciController){
        case PCI_CTRL_S593:
            S593_ClearController(OP_Port(pDevExt));
            break;
        case PCI_CTRL_PLX90:
        case PCI_CTRL_P9030:
            if(reset_9050)
                PLX90_ClearController(OP_Port(pDevExt));  //Alex 12/02/98
            break;
        case PCI_CTRL_P9080:
            P9080_ClearController(OP_Port(pDevExt));
            break;
        default:
            break;
    }
}


/*
 * Open Device assist func
 */
BOOLEAN AdlOpenDevice(PPCI_DEVEXT pDevExt)
{
    PPCI_DRVEXT pDrvExt;
    PPCI_DBX pDbx;
    DAS_IOT_FUNC_DESP *pFdsp;
    int vi;

    /*error check*/
    if(!pDevExt)
        return FALSE;
    if(!(pDrvExt = pDevExt->pDrvExt))
        return FALSE;
    if(pDevExt->Reference>0){
        //pDevExt->Reference ++;
        return TRUE;
    }

    /*PCI Controller Reset*/
    AdlControllerReset(pDevExt, 1);

    pFdsp = pDrvExt->CardDesp.mFunc;
    for(vi=0; vi<DAS_FUNC_COUNT; vi++, pFdsp++){
        pDbx = pDevExt->pDbx[vi];
        if(!pDbx)
            continue;
        //yuan add 11/05/04
        if(!pFdsp->wFlag.bFunction)
            continue;
        if((!(pFdsp->wFlag.bDMA))&&(!(pFdsp->wFlag.bInterrupt)))
            continue;
        if(!pFdsp->wArraySize)
            continue;
        /*Clear DAQ-Function parameters*/
        AdlOpenDbx(pDbx);
        pDbx->xFlag.f.DMA = pFdsp->wFlag.bDMA? 1:0;
        pDbx->xFlag.f.ChainDMA = pFdsp->wFlag.bChainDMA? 1:0;
        pDbx->wPacerMin = pDrvExt->wPacerMin[vi];
        /*resoulation <==> bytes per data, not apply to pci9113*/
        pDbx->wBytesPerData = (pFdsp->wResoluation+7)/8;
        pDbx->wCGArraySize = pFdsp->wArraySize;
        pDbx->xFlag.f.Output = DAS_FUNC_OUTPUT(vi);
        //removed 01/10/08
        //if(vi==2){
        //    volatile PPCI7300_DBXORUN pDbxORun;
        //    pDbxORun = (volatile PPCI7300_DBXORUN)(pDbx->xAddDbx[0].dwAddMap-DbxORunStructSize);
        //    pDbxORun->xFlag.f.extended = 1;
        //}
    }

    pDevExt->Reference = 0;
    return TRUE;
}
