#include "../include/Adlsys.h"
#include "../include/Adldev.h"
#include "../include/Adllib.h"
#include "../include/Adli8254.h"


/*
 * wErrorCode; wCounterIndex; wMode; wState; wBinBcd; dwCounterValue;
 */
U16 I8254_GetMode(DAS_IOT_CTR *pCtr)
{
    pCtr->wErrorCode = DAS_ERR_NO;

    if((pCtr->wCounterIndex>12)||(pCtr->dwCounterValue==1L)){
        pCtr->wErrorCode = DAS_ERR_COUNTER_NUMBER;
        return 0;
    }
    if((pCtr->wMode>5)||(pCtr->wBinBcd>1)){
        pCtr->wErrorCode = DAS_ERR_COUNTER_MODE;
        return 0;
    }

    return (pCtr->wCounterIndex<<6)|0x30|(pCtr->wMode<<1)|pCtr->wBinBcd;
}


int I8254L_IocCtrSet(U32 dwPort, DAS_IOT_CTR *pCtr)
{
    U32 dwCntrP;
    U16 wMode;

    wMode = I8254_GetMode(pCtr);
    if(!wMode)
        return 0;

    dwCntrP = dwPort+12;
    outD(dwCntrP, wMode);
    dwCntrP = dwPort+(pCtr->wCounterIndex<<2);
    outD(dwCntrP, FIRSTBYTE(pCtr->dwCounterValue));
    outD(dwCntrP, SECONDBYTE(pCtr->dwCounterValue));

    return 1;
}


int I8254W_IocCtrSet(U32 dwPort, DAS_IOT_CTR *pCtr)
{
    U32 dwCntrP;
    U16 wMode;

    wMode = I8254_GetMode(pCtr);
    if(!wMode)
        return 0;

    dwCntrP = dwPort+6;
    outW(dwCntrP, wMode);
    dwCntrP = dwPort+(pCtr->wCounterIndex<<1);
    outW(dwCntrP, FIRSTBYTE(pCtr->dwCounterValue));
    outW(dwCntrP, SECONDBYTE(pCtr->dwCounterValue));

    return 1;
}


int I8254B_IocCtrSet(U32 dwPort, DAS_IOT_CTR *pCtr)
{
    U32 dwCntrP;
    U16 wMode;

    wMode = I8254_GetMode(pCtr);
    if(!wMode)
        return 0;

    dwCntrP = dwPort+3;
    outB(dwCntrP, wMode);
    dwCntrP = dwPort+(pCtr->wCounterIndex);
    outB(dwCntrP, FIRSTBYTE(pCtr->dwCounterValue));
    outB(dwCntrP, SECONDBYTE(pCtr->dwCounterValue));

    return 1;
}


int I8254L_IocCtrGet(U32 dwPort, DAS_IOT_CTR *pCtr)
{
    U32 dwCntrP;

    if(pCtr->wCounterIndex>12){
        pCtr->wErrorCode = DAS_ERR_COUNTER_NUMBER;
        return 0;
    }

    pCtr->wErrorCode = DAS_ERR_NO;
    dwCntrP = dwPort+12;
    outD(dwCntrP, (pCtr->wCounterIndex<<6));
    dwCntrP = dwPort+(pCtr->wCounterIndex<<2);
    //pCtr->dwCounterValue =  inpD( dwCntrP );
    //pCtr->dwCounterValue |= (inpD( dwCntrP )<<8);
    pCtr->dwCounterValue =  inpB(dwCntrP);
    pCtr->dwCounterValue |= (inpB(dwCntrP)<<8);
    pCtr->dwCounterValue &= 0x0FFFF;

    return 1;
}


int I8254W_IocCtrGet(U32 dwPort, DAS_IOT_CTR *pCtr)
{
    U32 dwCntrP;

    if(pCtr->wCounterIndex>12){
        pCtr->wErrorCode = DAS_ERR_COUNTER_NUMBER;
        return 0;
    }

    pCtr->wErrorCode = DAS_ERR_NO;
    dwCntrP = dwPort+6;
    outW(dwCntrP, (pCtr->wCounterIndex<<6));
    dwCntrP = dwPort+(pCtr->wCounterIndex<<1);
    //pCtr->dwCounterValue =  inpW( dwCntrP );
    //pCtr->dwCounterValue |= (inpW( dwCntrP )<<8);
    pCtr->dwCounterValue =  inpB(dwCntrP);
    pCtr->dwCounterValue |= (inpB(dwCntrP)<<8);
    pCtr->dwCounterValue &= 0x0FFFF;

    return 1;
}


int I8254B_IocCtrGet(U32 dwPort, DAS_IOT_CTR *pCtr)
{
    U32 dwCntrP;

    if(pCtr->wCounterIndex>12){
        pCtr->wErrorCode = DAS_ERR_COUNTER_NUMBER;
        return 0;
    }

    pCtr->wErrorCode = DAS_ERR_NO;
    dwCntrP = dwPort+3;
    outB(dwCntrP, (pCtr->wCounterIndex<<6));
    dwCntrP = dwPort+pCtr->wCounterIndex;
    pCtr->dwCounterValue =  inpB(dwCntrP);
    pCtr->dwCounterValue |= (inpB(dwCntrP)<<8);
    pCtr->dwCounterValue &= 0x0FFFF;

    return 1;
}


int I8254B_IocCtrGetStatus(U32 dwPort, DAS_IOT_CTR *pCtr)
{
    U32 dwCntrP;

    if(pCtr->wCounterIndex>12){
        pCtr->wErrorCode = DAS_ERR_COUNTER_NUMBER;
        return 0;
    }

    pCtr->wErrorCode = DAS_ERR_NO;
    //printk("ReadPort: %x, CounterIndex: %d\n", dwPort, pCtr->wCounterIndex);
    dwCntrP = dwPort+3;
    outB(dwCntrP, (0xc0|(2<<(pCtr->wCounterIndex))));
    dwCntrP = dwPort+pCtr->wCounterIndex;
    pCtr->dwCounterValue =  inpB(dwCntrP);
    pCtr->dwCounterValue |= (inpB(dwCntrP)<<16);
    pCtr->dwCounterValue |= (inpB(dwCntrP)<<24);
    pCtr->dwCounterValue &= 0xff;

    return 1;
}
