#if defined(MODVERSIONS)
#include <linux/modversions.h>
#endif

#include "../include/Adlsys.h"
#include "../include/Adldev.h"
#include "../include/Adllib.h"

#include "../include/Adlplx90.h"
#include "pci7250.h"
#include <linux/interrupt.h>


/*>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>*/
static void p7250_bottom_half( PPCI_DEVEXT  pDevExt, U16 IntSrc )
{

    /*-----------------------------------------------------*/
    if ( ! pDevExt->pDin )
        return;

    if ( IntSrc & 0x0001 ){
        adl_kill_fasync ( pDevExt->pDin->async_queue1, SIGEVENT1); /* asynchronous readers */
    }
    if ( IntSrc & 0x0002 ){
        adl_kill_fasync ( pDevExt->pDin->async_queue2, SIGEVENT2);
    }

}

/*>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>*/
// based on request_irq() called in File_Open , and the dev_id is the Dev_Extension called request_irq()
#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,19)
irqreturn_t p7250_interrupt_handler(int irq, void *dev_id, struct pt_regs *regs)
#else
irqreturn_t p7250_interrupt_handler(int irq, void *dev_id)
#endif
{
    PPCI_DEVEXT  pDevExt;
    U16  wRetCode;  /* 980918/pang */

    /*-----------------------------------------------------*/
    pDevExt = (PCI_DEVEXT *)dev_id;
    wRetCode = PLX90_IsrCheckSource(OP_Port(pDevExt));
    if ((! (wRetCode & 0xff00))||(!(wRetCode & 0x0003)))
        return IRQ_NONE;

    if ( pDevExt->Reference <= 0)
        return IRQ_HANDLED;

/* Get Interrupt Enable setting */
    //if ( wRetCode & 0x0003 )
    p7250_bottom_half( pDevExt, wRetCode );

    // enable next INT after all operation finish
    PT_outb(PT_Port(pDevExt), CLRIRQ, 0);
    return IRQ_HANDLED;
}
