#include <stdio.h>
#include <string.h>
#include <stdlib.h>

typedef struct{
    int cards;
    int ai_page;
    int ao_page;
    int di_page;
    int do_page;
}
card_conf_info;

#define clrscr() printf("\033[H\033[J")

#define CONF_CARD_TYPE_NUM 42

char *CardName[] ={
    "",
    "PCI6202",
    "PCI6208",
    "PCI6308",
    "PCI7200",
    "PCI7230",
    "PCI7233",
    "PCI7234",
    "PCI7248",
    "PCI7249",
    "PCI7250",
    "PCI7252",
    "PCI7256",
    "PCI7258",
    "PCI7260",
    "PCI7296",
    "PCI7300A",
    "PCI7300B",
    "PCI7350", //
    "PCI7396",
    "PCI7432",
    "PCI7433",
    "PCI7433C",//
    "PCI7434",
    "PCI7434C",//
    "PCI7442",
    "PCI7443",
    "PCI7444",
    "PCI7452",
    "PCI9111",
    "PCI9112",
    "PCI9113",
    "PCI9114",
    "PCI9116",
    "PCI9118",
    "PCI9221",
    "PCI9222",//
    "PCI9223",//
    "PCI922A",//
    "PCI9524",//
    "PCI9812",
    "PCI8554"
};

char *header=
"**********************************************************************\n\
*****             DASK LINUX Configuration Utility               *****\n\
**********************************************************************\n\n";

char *menu_list=
" =========================================================\n\
(1)PCI6202   (2)PCI6208   (3)PCI6308   (4)PCI7200   (5)PCI7230 \n\
(6)PCI7233   (7)PCI7234   (8)PCI7248   (9)PCI7249   (10)PCI7250\n\
(11)PCI7252  (12)PCI7256  (13)PCI7258  (14)PCI7260  (15)PCI7296\n\
(16)PCI7300A RevA         (17)PCI7300A RevB         (18)PCI7350\n\
(19)PCI7396  (20)PCI7432  (21)PCI7433  (22)PCI7433C (23)PCI7434\n\
(24)PCI7434C (25)PCI7442  (26)PCI7443  (27)PCI7444  (28)PCI7452\n\
(29)PCI9111  (30)PCI9112  (31)PCI9113  (32)PCI9114  (33)PCI9116\n\
(34)PCI9118  (35)PCI9221  (36)PCI9222  (37)PCI9223  (38)PCI922A\n\
(39)PCI9524  (40)PCI9812  (41)PCI8554\n\
    Select the card type for configuration, or '0' to exit:";

char *config_list=
" ================== Configured Cards =====================\n\
Card Type   Cards     Buffer Size [unit: pages(4KB/page)]  \n\
                          AI      AO      DI      DO       \n\
-----------------------------------------------------------\n";

int card_type = 0;
int num_card = 0;
int mem_size = 0;
int mem_pages = 0;
int line_add;
card_conf_info card_list[CONF_CARD_TYPE_NUM];
int card_idx_7256[32];
int card_idx_7258[32];
int card_idx_7260[32];
int card_idx_7452[32];
int card_idx_7442[32];
int card_idx_7443[32];
int card_idx_7444[32];
int card_idx_7433c[32];
int card_idx_7434c[32];

void init_card_list(void)
{
    int i;

    for(i=0; i<CONF_CARD_TYPE_NUM; i++)
        memset(&(card_list[i]), '\0', sizeof(card_conf_info));
}


void recheck_lines(void)
{
    int i;
    num_card = 0;
    for(i=1; i<CONF_CARD_TYPE_NUM; i++){ // display configuration for cards
        if(card_list[i].cards>0){
            num_card++;
        }
    }
    //line_add = CONF_CARD_TYPE_NUM - num_card -2;
    line_add = CONF_CARD_TYPE_NUM-num_card-CONF_CARD_TYPE_NUM;
}


void recheck_mempage(void)
{
    int i;
    mem_pages = 0;
    num_card = 0;
    for(i=1; i<CONF_CARD_TYPE_NUM; i++){ // display configuration for cards
        if(card_list[i].cards>0){
            if(card_list[i].ai_page>0){
                if((strcmp(CardName[i], "PCI9221")==0)||
                    (strcmp(CardName[i], "PCI9222")==0)||
                    (strcmp(CardName[i], "PCI9223")==0)||
                    (strcmp(CardName[i], "PCI922A")==0)||
                    (strcmp(CardName[i], "PCI9524")==0))
                {
                    // additional one page for CalShareMemory
                    mem_pages += (((card_list[i].ai_page+255)/256+1+1)*\
                        card_list[i].cards);
                }
                else{
                    mem_pages += (card_list[i].ai_page*card_list[i].cards);
                }
            }
            if(card_list[i].ao_page>0){
                if((strcmp(CardName[i], "PCI6202")==0)||
                    (strcmp(CardName[i], "PCI9222")==0)||
                    (strcmp(CardName[i], "PCI9223")==0))
                {
                    // additional one page for CalShareMemory
                    mem_pages += (((card_list[i].ao_page+255)/256+1+1)*\
                        card_list[i].cards);
                }
                else{
                    mem_pages += (card_list[i].ao_page*card_list[i].cards);
                }
            }
            if(card_list[i].di_page>0){
                if((strcmp(CardName[i], "PCI7300A")==0)||
                    (strcmp(CardName[i], "PCI7300B")==0)||
                    (strcmp(CardName[i], "PCI7350")==0))
                {
                    mem_pages += (((card_list[i].di_page+255)/256+1)*\
                        card_list[i].cards);
                }
                else{
                    mem_pages += (card_list[i].di_page*card_list[i].cards);
                }
            }
            if(card_list[i].do_page>0){
                if((strcmp(CardName[i], "PCI7300A")==0)||
                    (strcmp(CardName[i], "PCI7300B")==0)||
                    (strcmp(CardName[i], "PCI7350")==0))
                {
                    mem_pages += (((card_list[i].do_page+255)/256+1)*\
                        card_list[i].cards);
                }
                else{
                    mem_pages += (card_list[i].do_page*card_list[i].cards);
                }
            }
            num_card ++;
        }
    }
    if(mem_pages>0){
        mem_size = mem_pages*4;
        clrscr();
        printf("\n\n The memory size you configure for your PCI-DASK adapters is %d Mem_Pages,\n", mem_pages );
        printf(" the minimum reserved memory you needed is %d KB.\n", mem_size );
        printf(" Please check the setting in /etc/lilo.conf. \n\n");
    }
}


void config_card(int type_idx)
{
    char card_type_string[25] = "Card_Type : ";
    int temp_card_num;
    int temp_ai_page = 0;
    int temp_ao_page = 0;
    int temp_di_page = 0;
    int temp_do_page = 0;
    char exit_char = 'n';
    int i;

    strcat(card_type_string, CardName[type_idx]);
    do{
        clrscr();
        printf(header);
        printf(card_type_string);
        printf("\n\n How many %s adapters in your machine : ", CardName[type_idx]);
        scanf("%d", &temp_card_num);
        getchar();
        if(temp_card_num==0)
            goto zero_recheck;

        switch(type_idx){
            case 1://PCI6202
                /*AO contigous operation*/
                printf(" Memory pages for AO function \( 1 Mem_Page = 4 KB ) : " );
                scanf(" %d", &temp_ao_page);
                getchar();
                break;
            case  2://PCI6208
            case  3://PCI6308
            case  5://PCI7230
            case  6://PCI7233
            case  7://PCI7234
            case  8://PCI7248
            case  9://PCI7249
            case 10://PCI7250
            case 11://PCI7252
            case 15://PCI7296
            case 19://PCI7396
            case 20://PCI7432
            case 21://PCI7433
            case 23://PCI7434
            case 41://PCI8554
                /*No DMA operation*/
                break;
            case 12://PCI7256
                /*Get board id*/
                printf(" Assign the card index for each PCI-7256\n\n");
                for(i=0; i<temp_card_num; i++){
                    printf(" PCI-7256#%d : ", i);
                    scanf(" %d", &(card_idx_7256[i]));
                    getchar();
                }
                break;
            case 13://PCI7258
                /*Get board id*/
                printf(" Assign the card index for each PCI-7258\n\n");
                for(i=0; i<temp_card_num; i++){
                    printf(" PCI-7258#%d : ", i);
                    scanf(" %d", &(card_idx_7258[i]));
                    getchar();
                }
                break;
            case 14://PCI7260
                /*Get board id*/
                printf(" Assign the card index for each PCI-7260\n\n");
                for(i=0; i<temp_card_num; i++){
                    printf(" PCI-7260#%d : ", i);
                    scanf(" %d", &(card_idx_7260[i]));
                    getchar();
                }
                break;
            case 22://PCI7433C
                /*Get board id*/
                printf(" Assign the card index for each PCI-7433C\n\n");
                for(i=0; i<temp_card_num; i++){
                    printf(" PCI-7233C#%d : ", i);
                    scanf(" %d", &(card_idx_7433c[i]));
                    getchar();
                }
                break;
            case 24://PCI7434C
                /*Get board id*/
                printf(" Assign the card index for each PCI-7434C\n\n");
                for(i=0; i<temp_card_num; i++){
                    printf(" PCI-7234C#%d : ", i);
                    scanf(" %d", &(card_idx_7434c[i]));
                    getchar();
                }
                break;
            case 25://PCI7442
                /*Get board id*/
                printf(" Assign the card index for each PCI-7442\n\n");
                for(i=0; i<temp_card_num; i++){
                    printf(" PCI-7442#%d : ", i);
                    scanf(" %d", &(card_idx_7442[i]));
                    getchar();
                }
                break;
            case 26://PCI7443
                /*Get board id*/
                printf(" Assign the card index for each PCI-7443\n\n");
                for(i=0; i<temp_card_num; i++){
                    printf(" PCI-7443#%d : ", i);
                    scanf(" %d", &(card_idx_7443[i]));
                    getchar();
                }
                break;
            case 27://PCI7444
                /*Get board id*/
                printf(" Assign the card index for each PCI-7444\n\n");
                for(i=0; i<temp_card_num; i++){
                    printf(" PCI-7444#%d : ", i);
                    scanf(" %d", &(card_idx_7444[i]));
                    getchar();
                }
                break;
            case 28://PCI7452
                /*Get board id*/
                printf(" Assign the card index for each PCI-7452\n\n");
                for(i=0; i<temp_card_num; i++){
                    printf(" PCI-7452#%d : ", i);
                    scanf(" %d", &(card_idx_7452[i]));
                    getchar();
                }
                break;
            case 29://PCI9111
            case 30://PCI9112
            case 31://PCI9113
            case 32://PCI9114
            case 33://PCI9116
            case 34://PCI9118
            case 35://PCI9221
            case 38://PCI922A
            case 39://PCI9524
            case 40://PCI9812
                /*AI contigous operation*/
                printf(" Memory pages for AI function \( 1 Mem_Page = 4 KB ) : " );
                scanf(" %d", &temp_ai_page);
                getchar();
                break;
            case 36://PCI9222
            case 37://PCI9223
                /*AI/AO/DI/DO contigous operations*/
                printf(" Memory pages for AI function \( 1 Mem_Page = 4 KB ) : " );
                scanf(" %d", &temp_ai_page);
                getchar();
                printf("\n\n Memory pages for AO function \( 1 Mem_Page = 4 KB ) : " );
                scanf(" %d", &temp_ao_page);
                getchar();
                printf("\n\n Memory pages for DI function \( 1 Mem_Page = 4 KB ) : " );
                scanf(" %d", &temp_di_page);
                getchar();
                printf("\n\n Memory pages for DO function \( 1 Mem_Page = 4 KB ) : " );
                scanf(" %d", &temp_do_page);
                getchar();
                break;
            case  4://PCI7200
            case 16://PCI7300A
            case 17://PCI7300B
            case 18://PCI7350
                /*DI/DO contigous operations*/
                printf(" Memory pages for DI function \( 1 Mem_Page = 4 KB ) : " );
                scanf(" %d", &temp_di_page);
                getchar();
                printf("\n\n Memory pages for DO function \( 1 Mem_Page = 4 KB ) : " );
                scanf(" %d", &temp_do_page);
                getchar();
        }
        printf("\n\n The setting for %s :\n---------------------------------------------------------------------------\n\
 AI: %d Pages    AO: %d Pages    DI: %d Pages    DO: %d Pages   for %d %s Cards \n",
            CardName[type_idx], temp_ai_page, temp_ao_page, temp_di_page,
            temp_do_page, temp_card_num, CardName[type_idx]
        );

zero_recheck:
        if(temp_card_num==0)
            printf("\n Cards for %s is zero, the %s will be deleted from configuration list \n",CardName[type_idx], CardName[type_idx] );
        printf("\n                                           are these correct (Y/N) ? ");
        scanf("%c", &exit_char);
        getchar();
    }while(exit_char!='y'&&exit_char!='Y');

    if(card_list[type_idx].cards>0&&temp_card_num==0 ) // delete configuration
        num_card --;
    else if(card_list[type_idx].cards==0&&temp_card_num>0) // add new configuration
        num_card ++;

    card_list[type_idx].cards = temp_card_num;
    card_list[type_idx].ai_page = temp_ai_page;
    card_list[type_idx].ao_page = temp_ao_page;
    card_list[type_idx].di_page = temp_di_page;
    card_list[type_idx].do_page = temp_do_page;

    recheck_lines();
}


int write_to_config_file(void)
{
    char *file_name = "../drivers/pcidask.conf";
    FILE *fp;
    char b7256_cfg = 0;
    char b7258_cfg = 0;
    char b7260_cfg = 0;
    char b7452_cfg = 0;
    char b7442_cfg = 0;
    char b7443_cfg = 0;
    char b7444_cfg = 0;
    char b7433c_cfg = 0;
    char b7434c_cfg = 0;

    int i;

    if((fp = fopen(file_name, "w+b"))==NULL){
        return 0;
    }

    fprintf(fp, config_list);
    for(i=1; i<CONF_CARD_TYPE_NUM; i++){ // display configuration for cards
        if(card_list[i].cards>0){
            fprintf(fp, "%s       %d            %d       %d       %d       %d\n",
                CardName[i], card_list[i].cards, card_list[i].ai_page,
                card_list[i].ao_page, card_list[i].di_page, card_list[i].do_page
            );
            if(i==12){
                b7256_cfg = 1;
            }
            else if(i==13){
                b7258_cfg = 1;
            }
            else if(i==14){
                b7260_cfg = 1;
            }
            else if(i==22){
                b7433c_cfg = 1;
            }
            else if(i==24){
                b7434c_cfg = 1;
            }
            else if(i==25){
                b7442_cfg = 1;
            }
            else if(i==26){
                b7443_cfg = 1;
            }
            else if(i==27){
                b7444_cfg = 1;
            }
            else if(i==28){
                b7452_cfg = 1;
            }
        }
    }

    if(b7256_cfg){
        char index_str[80] = "Index_7256 :";
        char tmp_str[20];

        for(i=0; i<card_list[12].cards; i++){
            sprintf(tmp_str, " %d", card_idx_7256[i]);
            strcat(index_str, tmp_str);
        }
        fprintf(fp, "\n\n%s\n", index_str);
    }
    if(b7258_cfg){
        char index_str[80] = "Index_7258 :";
        char tmp_str[20];

        for(i=0; i<card_list[13].cards; i++){
            sprintf(tmp_str, " %d", card_idx_7258[i]);
            strcat(index_str, tmp_str);
        }
        fprintf(fp, "\n\n%s\n", index_str);
    }
    if(b7260_cfg){
        char index_str[80] = "Index_7260 :";
        char tmp_str[20];

        for(i=0; i<card_list[14].cards; i++){
            sprintf(tmp_str, " %d", card_idx_7260[i]);
            strcat(index_str, tmp_str);
        }
        fprintf(fp, "\n\n%s\n", index_str);
    }
    if(b7433c_cfg){
        char index_str[80] = "Index_7433C :";
        char tmp_str[20];

        for(i=0; i<card_list[22].cards; i++){
            sprintf(tmp_str, " %d", card_idx_7433c[i]);
            strcat(index_str, tmp_str);
        }
        fprintf(fp, "\n\n%s\n", index_str);
    }
    if(b7434c_cfg){
        char index_str[80] = "Index_7434C :";
        char tmp_str[20];

        for(i=0; i<card_list[24].cards; i++){
            sprintf(tmp_str, " %d", card_idx_7434c[i]);
            strcat(index_str, tmp_str);
        }
        fprintf(fp, "\n\n%s\n", index_str);
    }
    if(b7442_cfg){
        char index_str[80] = "Index_7442 :";
        char tmp_str[20];

        for(i=0; i<card_list[25].cards; i++){
            sprintf(tmp_str, " %d", card_idx_7442[i]);
            strcat(index_str, tmp_str);
        }
        fprintf(fp, "\n\n%s\n", index_str);
    }
    if(b7443_cfg){
        char index_str[80] = "Index_7443 :";
        char tmp_str[20];

        for(i=0; i<card_list[26].cards; i++){
            sprintf(tmp_str, " %d", card_idx_7443[i]);
            strcat(index_str, tmp_str);
        }
        fprintf(fp, "\n\n%s\n", index_str);
    }
    if(b7444_cfg){
        char index_str[80] = "Index_7444 :";
        char tmp_str[20];

        for(i=0; i<card_list[27].cards; i++){
            sprintf(tmp_str, " %d", card_idx_7444[i]);
            strcat(index_str, tmp_str);
        }
        fprintf(fp, "\n\n%s\n", index_str);
    }
    if(b7452_cfg){
        char index_str[80] = "Index_7452 :";
        char tmp_str[20];

        for(i=0; i<card_list[28].cards; i++){
            sprintf(tmp_str, " %d", card_idx_7452[i]);
            strcat(index_str, tmp_str);
        }
        fprintf(fp, "\n\n%s\n", index_str);
    }

    if(fclose(fp))
        printf(" file close error in write_to_file \n");

    return 1;

}


int read_from_config_file(void)
{
    char *file_name = "../drivers/pcidask.conf";
    char str_card_type[15];
    char adl_prefix[] = "PCI";
    FILE *fp;
    char temp_line[80];
    int card_idx;
    int temp_num_cards, temp_ai_page, temp_ao_page, temp_di_page, temp_do_page;

    if((fp = fopen(file_name, "r+b"))==NULL)
           return 0;

    while(!feof(fp)){
        if(fgets(temp_line, 80, fp)==NULL)
            break; // error occur or EOF
        if(strstr(temp_line, "Index_7256 :")!=NULL){
            continue;
        }
        if(strstr(temp_line, "Index_7258 :")!=NULL){
            continue;
        }
        if(strstr(temp_line, "Index_7260 :")!=NULL){
            continue;
        }
        if(strstr(temp_line, "Index_7433C :")!=NULL){
            continue;
        }
        if(strstr(temp_line, "Index_7434C :")!=NULL){
            continue;
        }
        if(strstr(temp_line, "Index_7442 :")!=NULL){
            continue;
        }
        if(strstr(temp_line, "Index_7443 :")!=NULL){
            continue;
        }
        if(strstr(temp_line, "Index_7444 :")!=NULL){
            continue;
        }
        if(strstr(temp_line, "Index_7452 :")!=NULL){
            continue;
        }
        if(strstr(temp_line, adl_prefix)==NULL)
            continue; // skip the description line
        sscanf(temp_line, "%s       %d            %d       %d       %d       %d\n",
            str_card_type, &temp_num_cards, &temp_ai_page, &temp_ao_page,
            &temp_di_page, &temp_do_page
        );

        for(card_idx=1; card_idx<CONF_CARD_TYPE_NUM; card_idx++){
            if(!strcmp(CardName[card_idx], str_card_type))
                break;
        }
        if(card_idx==CONF_CARD_TYPE_NUM)
            continue; // the card_idx out of CARD_TYPE range , skip it!

        card_list[card_idx].cards = temp_num_cards;
        card_list[card_idx].ai_page = temp_ai_page;
        card_list[card_idx].ao_page = temp_ao_page;
        card_list[card_idx].di_page = temp_di_page;
        card_list[card_idx].do_page = temp_do_page;
    }

    fclose(fp);
    return 1;
}


int main(void)
{
    int i;

    clrscr();

    init_card_list();
    read_from_config_file();
    recheck_lines();

    do{
        clrscr();

        printf(config_list);
        for(i=1; i<CONF_CARD_TYPE_NUM; i++){ // display configuration for cards
            if(card_list[i].cards>0){
                printf( "%s       %d            %d       %d       %d       %d\n",
                    CardName[i],  card_list[i].cards,
                    card_list[i].ai_page, card_list[i].ao_page,
                    card_list[i].di_page, card_list[i].do_page
                );
            }
        }
        printf("\n");
        line_add --;
        for(i=0; i<line_add; i++)
            putchar('\n');
        printf(menu_list);
        scanf("%d", &card_type);
        getchar();

        if(card_type>0&&card_type<CONF_CARD_TYPE_NUM)
            config_card(card_type);
    }while(card_type!=0);

    write_to_config_file();
    recheck_mempage();

    return 1;
}
